-------------------------------------------------------------------------------
-- File name : mux321.vhdl
-- Title     : 32-1 Multiplexor
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity mux321 is
  port (D0  : in  std_logic;
        D1  : in  std_logic;
        D2  : in  std_logic;
        D3  : in  std_logic;
        D4  : in  std_logic;
        D5  : in  std_logic;
        D6  : in  std_logic;
        D7  : in  std_logic;
        D8  : in  std_logic;
        D9  : in  std_logic;
        D10  : in  std_logic;
        D11  : in  std_logic;
        D12  : in  std_logic;
        D13  : in  std_logic;
        D14  : in  std_logic;
        D15  : in  std_logic;
        D16  : in  std_logic;
        D17  : in  std_logic;
        D18  : in  std_logic;
        D19  : in  std_logic;
        D20  : in  std_logic;
        D21  : in  std_logic;
        D22  : in  std_logic;
        D23  : in  std_logic;
        D24  : in  std_logic;
        D25  : in  std_logic;
        D26  : in  std_logic;
        D27  : in  std_logic;
        D28  : in  std_logic;
        D29  : in  std_logic;
        D30  : in  std_logic;
        D31  : in  std_logic;
        S  : in  std_logic_vector(4 downto 0);
        Y  : out std_logic);
end mux321;

architecture structure of mux321 is

  component mux21
    port (D0 : in  std_logic;
          D1 : in  std_logic;
          S0 : in  std_logic;
          Y  : out std_logic);
  end component;

  signal w0, w1, w2, w3, w4      : std_logic;
  signal w5, w6, w7, w8, w9      : std_logic;
  signal w10, w11, w12, w13, w14 : std_logic;
  signal w15, w16, w17, w18, w19 : std_logic;
  signal w20, w21, w22, w23, w24 : std_logic;
  signal w25, w26, w27, w28, w29 : std_logic;      
  
begin

  mx1  : mux21 port map (D0, D1, S(0), w0);
  mx2  : mux21 port map (D2, D3, S(0), w1);
  mx3  : mux21 port map (D4, D5, S(0), w2);
  mx4  : mux21 port map (D6, D7, S(0), w3);
  mx5  : mux21 port map (D8, D9, S(0), w4);
  mx6  : mux21 port map (D10, D11, S(0), w5);
  mx7  : mux21 port map (D12, D13, S(0), w6);
  mx8  : mux21 port map (D14, D15, S(0), w7);
  mx9  : mux21 port map (D16, D17, S(0), w8);
  mx10 : mux21 port map (D18, D19, S(0), w9);
  mx11 : mux21 port map (D20, D21, S(0), w10);
  mx12 : mux21 port map (D22, D23, S(0), w11);
  mx13 : mux21 port map (D24, D25, S(0), w12);
  mx14 : mux21 port map (D26, D27, S(0), w13);
  mx15 : mux21 port map (D28, D29, S(0), w14);
  mx16 : mux21 port map (D30, D31, S(0), w15);  

  mx17 : mux21 port map (w0, w1, S(1), w16);
  mx18 : mux21 port map (w2, w3, S(1), w17);
  mx19 : mux21 port map (w4, w5, S(1), w18);
  mx20 : mux21 port map (w6, w7, S(1), w19);
  mx21 : mux21 port map (w8, w9, S(1), w20);
  mx22 : mux21 port map (w10, w11, S(1), w21);
  mx23 : mux21 port map (w12, w13, S(1), w22);
  mx24 : mux21 port map (w14, w15, S(1), w23);

  mx25 : mux21 port map (w16, w17, S(2), w24);
  mx26 : mux21 port map (w18, w19, S(2), w25);
  mx27 : mux21 port map (w20, w21, S(2), w26);
  mx28 : mux21 port map (w22, w23, S(2), w27);

  mx29 : mux21 port map (w24, w25, S(3), w28);
  mx30 : mux21 port map (w26, w27, S(3), w29);    

  mx31 : mux21 port map (w28, w29, S(4), Y);    

end structure;
