-- Different Registers
-- Author: John Moskal
--  Created: 11-26-04
-- Modified: 11-26-04
--
-- Modifications:
--
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity dff is
port
(
        D:      in std_logic;
        clk:    in std_logic;
        rst:    in std_logic;
        Q:      out std_logic
);
end entity dff;
--------------------------------------------

architecture stuff of dff is
begin

    process(D, clk, rst)
    begin

        -- clock rising edge
        if (rst='1') then 
           Q <= '0';
        elsif ((clk'event) and (clk='1')) then
           Q <= D;
        end if;

    end process;

end stuff;

-----------------------------------------------------------------------
-----------------------------------------------------------------------

library WORK;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
-------------------------------------------

entity reg3 is
port
(
        input:  in std_logic_vector(2 downto 0);
        stb:    in std_logic;
        rst:    in std_logic;
        output:   out std_logic_vector(2 downto 0)
);
end entity reg3;
--------------------------------------------

architecture stuff of reg3 is

component dff
port
(   
        D:      in std_logic;
        clk:    in std_logic;
        rst:    in std_logic;
        Q:      out std_logic
);
end component;

signal stb_w:   std_logic;
signal rst_w:   std_logic;

begin

stb_w <= stb;
rst_w <= rst;

R0:     dff port map(input(0), stb_w, rst_w, output(0));
R1:     dff port map(input(1), stb_w, rst_w, output(1));
R2:     dff port map(input(2), stb_w, rst_w, output(2));

end stuff;

-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------

library WORK;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
-------------------------------------------

entity reg4 is
port
(
        input:  in std_logic_vector(3 downto 0);
        stb:    in std_logic;
        rst:    in std_logic;
        output:   out std_logic_vector(3 downto 0)
);
end entity reg4;
--------------------------------------------

architecture stuff of reg4 is

component dff
port
(   
        D:      in std_logic;
        clk:    in std_logic;
        rst:    in std_logic;
        Q:      out std_logic
);
end component;

signal stb_w:   std_logic;
signal rst_w:   std_logic;

begin

stb_w <= stb;
rst_w <= rst;

R0:     dff port map(input(0), stb_w, rst_w, output(0));
R1:     dff port map(input(1), stb_w, rst_w, output(1));
R2:     dff port map(input(2), stb_w, rst_w, output(2));
R3:     dff port map(input(3), stb_w, rst_w, output(3));

end stuff;

-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity reg5 is
port
(
        input:    in std_logic_vector(4 downto 0);
        stb:      in std_logic;
        rst:      in std_logic;
        output:   out std_logic_vector(4 downto 0)
);
end entity reg5;

------------------------------------------------------------------------------------------

architecture stuff of reg5 is

-- COMPONENTS --

component dff
port
(   
        D:      in std_logic;
        clk:    in std_logic;
        rst:    in std_logic;
        Q:      out std_logic
);
end component;

-- SIGNALS --

signal stb_w:   std_logic;
signal rst_w:   std_logic;

-- HDL --

begin
    
stb_w <= stb;
rst_w <= rst;

R0:     dff port map(input(0), stb_w, rst_w, output(0));
R1:     dff port map(input(1), stb_w, rst_w, output(1));
R2:     dff port map(input(2), stb_w, rst_w, output(2));
R3:     dff port map(input(3), stb_w, rst_w, output(3));
R4:     dff port map(input(4), stb_w, rst_w, output(4));

end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity reg32 is
port
(
        input:    in std_logic_vector(31 downto 0);
        stb:      in std_logic;
        rst:      in std_logic;
        output:   out std_logic_vector(31 downto 0)
);
end entity reg32;

------------------------------------------------------------------------------------------

architecture stuff of reg32 is

-- COMPONENTS --

component dff
port
(   
        D:      in std_logic;
        clk:    in std_logic;
        rst:    in std_logic;
        Q:      out std_logic
);
end component;

-- SIGNALS --

signal stb_w:   std_logic;
signal rst_w:   std_logic;

-- HDL --

begin
    
stb_w <= stb;
rst_w <= rst;

R00:     dff port map(input(00), stb_w, rst_w, output(00));
R01:     dff port map(input(01), stb_w, rst_w, output(01));
R02:     dff port map(input(02), stb_w, rst_w, output(02));
R03:     dff port map(input(03), stb_w, rst_w, output(03));
R04:     dff port map(input(04), stb_w, rst_w, output(04));
R05:     dff port map(input(05), stb_w, rst_w, output(05));
R06:     dff port map(input(06), stb_w, rst_w, output(06));
R07:     dff port map(input(07), stb_w, rst_w, output(07));
R08:     dff port map(input(08), stb_w, rst_w, output(08));
R09:     dff port map(input(09), stb_w, rst_w, output(09));
R10:     dff port map(input(10), stb_w, rst_w, output(10));
R11:     dff port map(input(11), stb_w, rst_w, output(11));
R12:     dff port map(input(12), stb_w, rst_w, output(12));
R13:     dff port map(input(13), stb_w, rst_w, output(13));
R14:     dff port map(input(14), stb_w, rst_w, output(14));
R15:     dff port map(input(15), stb_w, rst_w, output(15));
R16:     dff port map(input(16), stb_w, rst_w, output(16));
R17:     dff port map(input(17), stb_w, rst_w, output(17));
R18:     dff port map(input(18), stb_w, rst_w, output(18));
R19:     dff port map(input(19), stb_w, rst_w, output(19));
R20:     dff port map(input(20), stb_w, rst_w, output(20));
R21:     dff port map(input(21), stb_w, rst_w, output(21));
R22:     dff port map(input(22), stb_w, rst_w, output(22));
R23:     dff port map(input(23), stb_w, rst_w, output(23));
R24:     dff port map(input(24), stb_w, rst_w, output(24));
R25:     dff port map(input(25), stb_w, rst_w, output(25));
R26:     dff port map(input(26), stb_w, rst_w, output(26));
R27:     dff port map(input(27), stb_w, rst_w, output(27));
R28:     dff port map(input(28), stb_w, rst_w, output(28));
R29:     dff port map(input(29), stb_w, rst_w, output(29));
R30:     dff port map(input(30), stb_w, rst_w, output(30));
R31:     dff port map(input(31), stb_w, rst_w, output(31));

end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

-- By Ivan D. Castellanos
library work;
library ieee;
use ieee.std_logic_1164.all;

entity register32 is
  port (d   : in  std_logic_vector(31 downto 0);
        clk : in  std_logic;
        q   : out std_logic_vector(31 downto 0));
end register32;

architecture behavior of register32 is
begin
  process (clk)
  begin
    if (clk'event and clk = '1') then
      q <= d;
    end if;
  end process; 
end behavior;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------

-- By Ivan D. Castellanos
-- Modified by John Moskal

library work;
library ieee;
use ieee.std_logic_1164.all;

entity register32j is
port 
(
   d   : in  std_logic_vector(31 downto 0);
   clk : in  std_logic;
   rst : in  std_logic;
   init: in  std_logic_vector(31 downto 0);
   q   : out std_logic_vector(31 downto 0)
);
end register32j;

architecture behavior of register32j is
begin
  process (clk, rst)
  begin
    if (rst = '1') then
       q <= init;
    else 
       if (clk'event and clk = '1') then
         q <= d;
       end if;
   end if;
  end process; 
end behavior;
